defmodule Historian.Styles do
  @moduledoc false

  @black_and_white_light %{
    archive_item_current_line_background: :white,
    archive_item_current_line_text: :black,
    archive_panel_background: :white,
    archive_panel_title_text: :black,
    archive_status_bar_background: :black,
    archive_status_bar_text: :white,
    dialog_box_button_background: :white,
    dialog_box_button_background_selected: :black,
    dialog_box_panel_background: :black,
    dialog_box_cancel_text: :black,
    dialog_box_confirm_text: :black,
    dialog_box_content_text: :black,
    dialog_box_label_background: :white,
    dialog_box_label_background_selected: :black,
    dialog_box_label_content_text: :black,
    dialog_box_label_text: :black,
    dialog_box_label_text_selected: :white,
    dialog_box_panel_text: :white,
    history_current_line_background: :white,
    history_current_line_text: :black,
    history_line_background: :default,
    history_line_text: :default,
    history_line_copied_line_ok: :black,
    history_line_copied_line_background: :default,
    history_line_multiselect_background_selected: :black,
    history_line_multiselect_text_selected: :white,
    history_split_view_panel_background: :white,
    history_split_view_panel_title_text: :black,
    history_status_bar_background: :black,
    history_status_bar_text: :white,
    screen_navigation_app_name_background: :black,
    screen_navigation_app_name_text: :white,
    screen_navigation_background: :white,
    screen_navigation_text: :black,
    screen_navigation_text_selected: :black,
    search_item_matching_text: :black,
    search_item_matching_text_selected: :black,
    search_status_bar_background: :black,
    search_status_bar_text: :white
  }

  @black_and_white_dark %{
    archive_item_current_line_background: :white,
    archive_item_current_line_text: :black,
    archive_panel_background: :black,
    archive_panel_title_text: :white,
    archive_status_bar_background: :white,
    archive_status_bar_text: :black,
    dialog_box_button_background: :black,
    dialog_box_button_background_selected: :white,
    dialog_box_panel_background: :white,
    dialog_box_cancel_text: :white,
    dialog_box_confirm_text: :white,
    dialog_box_content_text: :white,
    dialog_box_label_background: :black,
    dialog_box_label_background_selected: :white,
    dialog_box_label_content_text: :white,
    dialog_box_label_text: :white,
    dialog_box_label_text_selected: :black,
    dialog_box_panel_text: :black,
    history_current_line_background: :white,
    history_current_line_text: :black,
    history_line_background: :default,
    history_line_text: :white,
    history_line_copied_line_ok: :black,
    history_line_copied_line_background: :white,
    history_line_multiselect_background_selected: :white,
    history_line_multiselect_text_selected: :black,
    history_split_view_panel_background: :black,
    history_split_view_panel_title_text: :white,
    history_status_bar_background: :white,
    history_status_bar_text: :black,
    screen_navigation_app_name_background: :white,
    screen_navigation_app_name_text: :black,
    screen_navigation_background: :black,
    screen_navigation_text: :white,
    screen_navigation_text_selected: :white,
    search_item_matching_text: :white,
    search_item_matching_text_selected: :black,
    search_status_bar_background: :white,
    search_status_bar_text: :black
  }

  @high_contrast_dark %{
    archive_item_current_line_background: :magenta,
    archive_item_current_line_text: :white,
    archive_panel_background: :blue,
    archive_panel_title_text: :black,
    archive_status_bar_background: :blue,
    archive_status_bar_text: :black,
    dialog_box_button_background: :blue,
    dialog_box_button_background_selected: :magenta,
    dialog_box_panel_background: :blue,
    dialog_box_cancel_text: :black,
    dialog_box_confirm_text: :black,
    dialog_box_content_text: :white,
    dialog_box_label_background: :blue,
    dialog_box_label_background_selected: :magenta,
    dialog_box_label_content_text: :white,
    dialog_box_label_text: :black,
    dialog_box_label_text_selected: :white,
    dialog_box_panel_text: :black,
    history_current_line_background: :magenta,
    history_line_background: :default,
    history_line_text: :white,
    history_line_copied_background: :default,
    history_line_copied_line_ok: :white,
    history_line_multiselect_background_selected: :blue,
    history_line_multiselect_text_selected: :white,
    history_split_view_panel_background: :blue,
    history_split_view_panel_title_text: :black,
    history_status_bar_background: :blue,
    history_status_bar_text: :black,
    screen_navigation_app_name_background: :magenta,
    screen_navigation_app_name_text: :white,
    screen_navigation_background: :white,
    screen_navigation_text: :black,
    screen_navigation_text_selected: :magenta,
    search_item_matching_text: :white,
    search_item_matching_text_selected: :white,
    search_status_bar_background: :blue,
    search_status_bar_text: :black
  }

  @high_contrast_light %{
    archive_item_current_line_background: :magenta,
    archive_item_current_line_text: :white,
    archive_panel_background: :blue,
    archive_panel_title_text: :white,
    archive_status_bar_background: :blue,
    archive_status_bar_text: :white,
    dialog_box_button_background: :blue,
    dialog_box_button_background_selected: :magenta,
    dialog_box_cancel_text: :white,
    dialog_box_confirm_text: :white,
    dialog_box_content_text: :white,
    dialog_box_label_background: :blue,
    dialog_box_label_background_selected: :magenta,
    dialog_box_label_content_text: :black,
    dialog_box_label_text: :white,
    dialog_box_label_text_selected: :white,
    dialog_box_panel_background: :blue,
    dialog_box_panel_text: :white,
    history_current_line_background: :magenta,
    history_current_line_text: :white,
    history_line_background: :default,
    history_line_text: :default,
    history_line_copied_line_background: :default,
    history_line_copied_line_ok: :blue,
    history_line_multiselect_background_selected: :blue,
    history_line_multiselect_text_selected: :white,
    history_split_view_panel_background: :blue,
    history_split_view_panel_title_text: :white,
    history_status_bar_background: :blue,
    history_status_bar_text: :white,
    screen_navigation_app_name_background: :magenta,
    screen_navigation_app_name_text: :white,
    screen_navigation_background: :white,
    screen_navigation_text: :black,
    screen_navigation_text_selected: :magenta,
    search_item_matching_text: :black,
    search_item_matching_text_selected: :white,
    search_status_bar_background: :blue,
    search_status_bar_text: :white
  }

  @default %{
    archive_item_current_line_background: :black,
    archive_item_current_line_text: :white,
    archive_panel_background: :black,
    archive_panel_title_text: :cyan,
    archive_status_bar_background: :green,
    archive_status_bar_text: :black,
    dialog_box_button_background: :white,
    dialog_box_button_background_selected: :yellow,
    dialog_box_cancel_text: :red,
    dialog_box_confirm_text: :green,
    dialog_box_content_text: :yellow,
    dialog_box_label_background: :white,
    dialog_box_label_background_selected: :yellow,
    dialog_box_label_content_text: :yellow,
    dialog_box_label_text: :black,
    dialog_box_label_text_selected: :black,
    dialog_box_panel_background: :white,
    dialog_box_panel_text: :black,
    history_current_line_background: :black,
    history_current_line_text: :white,
    history_line_background: :default,
    history_line_copied_line_background: :default,
    history_line_copied_line_ok: :yellow,
    history_line_multiselect_background_selected: :black,
    history_line_multiselect_text_selected: :blue,
    history_line_text: :white,
    history_split_view_panel_background: :black,
    history_split_view_panel_title_text: :cyan,
    history_status_bar_background: :magenta,
    history_status_bar_text: :white,
    screen_navigation_app_name_background: :cyan,
    screen_navigation_app_name_text: :black,
    screen_navigation_background: :black,
    screen_navigation_text: :white,
    screen_navigation_text_selected: :cyan,
    search_item_matching_text: :cyan,
    search_item_matching_text_selected: :cyan,
    search_status_bar_background: :yellow,
    search_status_bar_text: :black
  }

  @typedoc "Possible color scheme names"
  @type color_schemes ::
          :black_and_white_dark
          | :black_and_white_light
          | :hight_contrast_dark
          | :high_contrast_light
          | :default

  @spec color_scheme(scheme_name :: color_schemes | nil) :: map()
  def color_scheme(name) do
    case name do
      :black_and_white_dark -> @black_and_white_dark
      :black_and_white_light -> @black_and_white_light
      :default -> @default
      :high_contrast_dark -> @high_contrast_dark
      :high_contrast_light -> @high_contrast_light
      _ -> %{}
    end
  end
end
